<script lang="ts">
  import { tick } from 'svelte';
  import Modal from '$lib/Modal.svelte';

  /** @type {import('./$types').PageData} */
  export let data: {
    [key: string]: employeeAttributes;
  };

  let employees = data;

  let nameInput: HTMLElement;
  let showModal = false;

  type employeeAttributes = {
    has_vog: boolean;
  };

  let currentEmployee: {
    name: string;
    attributes: employeeAttributes;
    originalName?: string;
  } = {
    name: '',
    attributes: {
      has_vog: false,
    },
    originalName: undefined,
  };

  async function openModal() {
    showModal = true;

    await tick();
    nameInput.focus();
  }

  function closeModal() {
    showModal = false;
  }

  function storeEmployees() {
    // Send a request to the the backend to store the employees
    fetch(`${import.meta.env.VITE_BACKEND_ADDRESS || 'http://localhost:8080'}/employees`, {
      method: 'PUT',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify(employees),
    })
      .then((response) => {
        // Check if the request was successful (status code in the range 200-299)
        if (!response.ok) {
          throw new Error(`fetch error, status: ${response.status}`);
        }
      })
      .catch((error) => {
        // Handle errors
        console.error('Fetch error:', error);
      });
  }
</script>

<svelte:head>
  <title>PIP data editor — Digilab</title>
</svelte:head>

<div class="container mx-auto p-4">
  <h1 class="mb-4 text-3xl font-semibold">Werknemers</h1>

  <p class="mb-6">
    <button
      on:click={() => {
        currentEmployee = { name: '', attributes: { has_vog: false } };
        openModal();
      }}
      class="inline-flex items-center rounded-lg border border-indigo-700 bg-indigo-600 px-2.5 py-1.5 text-sm font-medium text-white shadow-sm hover:border-indigo-800 hover:bg-indigo-700 focus:outline-none focus:ring-4 focus:ring-indigo-100"
    >
      <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
        <path
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M12 5v14m-7-7h14"
        />
      </svg>
      Werknemer toevoegen
    </button>
  </p>

  <div class="overflow-x-auto">
    <table class="w-full text-left">
      <thead class="bg-slate-100 text-sm uppercase text-gray-700">
        <tr>
          <th scope="col" class="px-4 py-3">Naam</th>
          <th scope="col" class="px-4 py-3">Heeft VOG</th>
          <th scope="col" class="px-4 py-3">Acties</th>
        </tr>
      </thead>
      <tbody>
        {#each Object.entries(employees).sort( ([a], [b]) => a.localeCompare(b), ) as [name, attributes]}
          <tr class="border-t border-slate-200">
            <td class="p-4">
              <button
                on:click={() => {
                  // Deep copy the object
                  currentEmployee = { name, attributes: { ...attributes }, originalName: name };
                  openModal();
                }}
                class="cursor-pointer text-blue-600 hover:text-blue-700 hover:underline"
                type="button"
              >
                {name}
              </button>
            </td>
            <td class="p-4">
              {#if attributes.has_vog}
                <svg
                  xmlns="http://www.w3.org/2000/svg"
                  class="inline-block h-5 w-5 align-text-bottom text-emerald-600"
                  viewBox="0 0 24 24"
                  ><path
                    fill="none"
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="m5 12l5 5L20 7"
                  /></svg
                >
                Ja
              {:else}
                <svg
                  xmlns="http://www.w3.org/2000/svg"
                  class="inline-block h-5 w-5 align-text-bottom text-rose-600"
                  viewBox="0 0 24 24"
                  ><path
                    fill="none"
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M18 6L6 18M6 6l12 12"
                  /></svg
                >
                Nee
              {/if}
            </td>
            <td class="p-4">
              <button
                on:click={() => {
                  // Deep copy the object
                  currentEmployee = { name, attributes: { ...attributes }, originalName: name };
                  openModal();
                }}
                type="button"
                class="text-slate-500 hover:text-indigo-700"
                ><svg class="h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
                  ><path
                    fill="none"
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M4 20h4L18.5 9.5a2.828 2.828 0 1 0-4-4L4 16zm9.5-13.5l4 4"
                  ></path></svg
                ></button
              >
              <button
                on:click={() => {
                  if (confirm('Weet je zeker dat je deze medewerker wilt verwijderen?')) {
                    delete employees[name];
                    // Reassign the object to trigger reactivity
                    employees = { ...employees };
                    storeEmployees();
                  }
                }}
                type="button"
                class="text-slate-500 hover:text-rose-700"
                ><svg class="h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
                  ><path
                    fill="none"
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M4 7h16m-10 4v6m4-6v6M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2l1-12M9 7V4a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v3"
                  ></path></svg
                ></button
              >
            </td>
          </tr>
        {:else}
          <tr class="border-t border-slate-200">
            <td class="p-4 text-center" colspan="3">Nog geen medewerkers gevonden.</td>
          </tr>
        {/each}
      </tbody>
    </table>
  </div>
</div>

<Modal bind:showModal>
  <h2 slot="header" class="mb-5 border-b border-slate-200 pb-4 text-2xl font-medium">Werknemer</h2>

  <form
    on:submit={() => {
      if (currentEmployee.originalName !== undefined) {
        delete employees[currentEmployee.originalName];
      }
      employees[currentEmployee.name] = currentEmployee.attributes;
      closeModal();
      storeEmployees();
    }}
  >
    <p class="mb-1">Naam</p>
    <p class="mb-4">
      <input
        bind:value={currentEmployee.name}
        bind:this={nameInput}
        type="text"
        class="inline-block w-80 rounded-lg border border-gray-300 p-2.5 text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
        placeholder="Naam van de medewerker"
        autocomplete="off"
      />
    </p>

    <p class="mb-1">Heeft VOG</p>
    <p class="mb-4">
      <label class="mb-5 inline-flex cursor-pointer items-center">
        <input
          bind:checked={currentEmployee.attributes.has_vog}
          type="checkbox"
          class="peer sr-only"
        />
        <div
          class="peer relative h-6 w-11 rounded-full bg-gray-200 after:absolute after:start-[2px] after:top-[2px] after:h-5 after:w-5 after:rounded-full after:border after:border-gray-300 after:bg-white after:transition-all after:content-[''] peer-checked:bg-indigo-600 peer-checked:after:translate-x-full peer-checked:after:border-white peer-focus:outline-none peer-focus:ring-4 peer-focus:ring-indigo-100 rtl:peer-checked:after:-translate-x-full"
        ></div>
      </label>
    </p>

    <button
      type="submit"
      class="inline-block rounded-lg border border-indigo-700 bg-indigo-600 px-2.5 py-1.5 text-sm font-medium text-white shadow-sm hover:border-indigo-800 hover:bg-indigo-700 focus:outline-none focus:ring-4 focus:ring-indigo-100"
      >Opslaan</button
    >
    <button
      on:click={closeModal}
      type="button"
      class="inline-block rounded-lg border border-gray-700 bg-white px-2.5 py-1.5 text-sm font-medium text-gray-700 shadow-sm hover:border-gray-800 hover:bg-gray-100 hover:text-gray-800 focus:outline-none focus:ring-4 focus:ring-gray-100"
      >Annuleren</button
    >
  </form>
</Modal>
